#!/usr/bin/env bash
set -euo pipefail

PATH=/bin:/usr/local/bin:/usr/bin:/usr/bin/env:/snap/bin
export PATH

URL={{ restic_url | default('not_defined') }}

# Define function restic_snapshots
restic_snapshots(){
{{ restic_command }} --no-lock --json --host $(hostname) snapshots | jq 'select(. !=null) | group_by(.paths) | map({"paths": .[0].paths, "oldest_snapshot": .[0].time, "newest_snapshot": .[-1].time, "number_of_snapshots":length})'
}

# Define function restic_stats_latest
restic_stats_latest(){
{{ restic_command }} --no-lock --json --host $(hostname) stats latest || true
}

# Define function restic_url
restic_url(){
jq -n --arg url "$URL" '{"url": $url}'
}

# Run functions
restic_snapshots > /etc/ansible/facts.d/restic_snapshots.fact
restic_stats_latest > /etc/ansible/facts.d/restic_stats_latest.fact
restic_url > /etc/ansible/facts.d/restic_url.fact
